
#include <stdlib.h>
#include <math.h>
#include "pointsort.h"


/* restituisce la distanza di un punto dall'origine */
double distance(struct POINT p)
{
 return sqrt(p.X*p.X + p.Y*p.Y);
}

struct POINT* pointSort(struct POINT vett[], int N)
{
 int i, swap;
 struct POINT temp;
 struct POINT *sort;

 sort = malloc(N*sizeof(struct POINT)); // allocazione del vettore
 for (i=0; i<N; i++) // copia degli elementi del vettore
    sort[i] = vett[i];

 do
   {
    swap = 0;
    for (i=0; i<N-1; i++)
       if (distance(sort[i]) > distance(sort[i+1]))
         {
          // scambio elementi
          temp = sort[i];
          sort[i] = sort[i+1];
          sort[i+1] = temp;
          swap = 1;
         }
   } while(swap);
 
 return sort;
}
